import argparse
import json
from typing import Text


def create_mlflow_report(
        mlflow_report_path: Text,
        mlflow_server: Text
) -> None:
    """Publishes MLflow run information.
    Args:
        mlflow_report_path {Text}: path to mlflow report generated by stage log_metrics
        mlflow_report_path {Text}: mlflow server URL
    """

    with open(mlflow_report_path) as mrf:

        report = json.load(mrf)

        exp_id = report['exp_id']
        run_id = report['run_id']
        run_uri = f'{mlflow_server}/#/experiments/{exp_id}/runs/{run_id}'

        print(f'Experiment id: {exp_id}\n')
        print(f'Experiment name: {report["exp_name"]}\n')
        print(f'Run id: {run_id}\n')
        print(f'Run URI: {run_uri}')


if __name__ == '__main__':

    args_parser = argparse.ArgumentParser()
    args_parser.add_argument('--mlflow-report', dest='mlflow_report')
    args_parser.add_argument('--mlflow-server', dest='mlflow_server')
    args = args_parser.parse_args()

    create_mlflow_report(
        mlflow_report_path=args.mlflow_report,
        mlflow_server=args.mlflow_server
    )
